--- a/tn7dsl.c
+++ b/tn7dsl.c
@@ -117,6 +117,7 @@
 #include <linux/vmalloc.h>
 #include <linux/file.h>
 #include <linux/firmware.h>
+#include <linux/version.h>
 
 #include <asm/io.h>
 #include <asm/ar7/ar7.h>
@@ -492,7 +493,9 @@ static void avsar_release(struct device
 }
 
 static struct device avsar = {
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,30)
 	.bus_id    = "vlynq",
+#endif
 	.release   = avsar_release,
 };
 
@@ -501,6 +504,9 @@ int shim_osLoadFWImage(unsigned char *pt
 	const struct firmware *fw_entry;
 	size_t size;
 
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,30)
+	dev_set_name(&avsar, "avsar");
+#endif
 	printk("requesting firmware image \"ar0700xx.bin\"\n");
 	if(device_register(&avsar) < 0) {
 		printk(KERN_ERR
